/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.util.DBConnect
 *  com.jiuqi.util.DuplicationException
 *  com.jiuqi.util.IntValue
 *  com.jiuqi.util.JqLib
 *  com.jiuqi.util.SequencialList
 */
package com.jiuqi.mde;

import com.jiuqi.mde.MDEDataInfo;
import com.jiuqi.mde.MDEDimValueSet;
import com.jiuqi.mde.MDEDimValueSetCollection;
import com.jiuqi.mde.MDEDimension;
import com.jiuqi.mde.MDEDimensionSet;
import com.jiuqi.mde.MDEException;
import com.jiuqi.mde.MDEField;
import com.jiuqi.mde.MDERecord;
import com.jiuqi.mde.MDERecordSet;
import com.jiuqi.mde.MDESqlLogger;
import com.jiuqi.mde.StatementCache;
import com.jiuqi.util.DBConnect;
import com.jiuqi.util.DuplicationException;
import com.jiuqi.util.IntValue;
import com.jiuqi.util.JqLib;
import com.jiuqi.util.SequencialList;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

public class MDETable
extends MDERecordSet {
    public static boolean KEEP_FIELDS_ORDER = false;
    public boolean keepFieldsOrder;
    protected StatementCache stmtCache = new StatementCache();
    protected MDEDimValueSetCollection loadedDimValues = new MDEDimValueSetCollection();
    private static final Integer DEFAULT_INT_VALUE = new Integer(999);
    private static final String DEFAULT_STR_VALUE = "_";

    public MDETable(MDEDataInfo dataInfo) {
        super(dataInfo);
        this.keepFieldsOrder = KEEP_FIELDS_ORDER;
    }

    public MDERecord createRecord() {
        return new MDERecord(this.dataInfo);
    }

    public final MDERecord newRecord() throws MDEException {
        try {
            return this.newRecord(null);
        }
        catch (DuplicationException ex) {
            ex.printStackTrace();
            return null;
        }
    }

    public final MDERecord newRecord(MDEDimValueSet dimValues) throws DuplicationException, MDEException {
        return this.newRecord(dimValues, true);
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public final MDERecord newRecord(MDEDimValueSet dimValues, boolean checkNeedLoad) throws DuplicationException, MDEException {
        MDERecord result = null;
        if (this.getIsUseLoadDataSync()) {
            result = this.dvFind(dimValues);
            if (result == null) {
                Object object = this.mutexLoadData;
                synchronized (object) {
                    result = this.dvFind(dimValues);
                    if (result == null) {
                        result = this.newRecord0(dimValues, checkNeedLoad);
                    }
                }
            }
        } else {
            result = this.newRecord0(dimValues, checkNeedLoad);
        }
        return result;
    }

    private MDERecord newRecord0(MDEDimValueSet dimValues, boolean checkNeedLoad) throws MDEException, DuplicationException {
        MDERecord result = this.createRecord();
        result.beforeNewRecord();
        if (dimValues != null) {
            result.setDimValues(dimValues, null);
        }
        result.afterNewRecord();
        if (dimValues != null && checkNeedLoad && !this.dataInfo.isTemporary() && this.needLoadData(result.getDimValues())) {
            System.out.println(String.valueOf(this.dataInfo.getName()) + "应该首先载入数据，否则无法定位记录序号");
        }
        try {
            this.add(result);
        }
        catch (DuplicationException ex) {
            if (this.hasOrder) {
                result.getDimValues().setValue("顺序号", null);
                this.add(result);
            }
            throw ex;
        }
        result.calculateDefaultValues();
        return result;
    }

    public final List getRecords(DBConnect dbConnect, MDEDimValueSet dimValues) throws MDEException {
        this.loadData(dbConnect, dimValues);
        return this.dvFindMatches(dimValues);
    }

    public final MDERecord getRecord(DBConnect dbConnect, MDEDimValueSet dimValues, boolean createIfNotExist) throws MDEException {
        MDERecord result;
        if (!dimValues.dimensions().equals(this.dataInfo.dimensions())) {
            MDEDimValueSet newDimValues = new MDEDimValueSet(this.dataInfo.dimensions());
            newDimValues.assignValues(dimValues);
            dimValues = newDimValues;
        }
        if ((result = this.dvFind(dimValues)) == null) {
            List records = this.getRecords(dbConnect, dimValues);
            if (records != null && records.size() > 1) {
                throw new MDEException(String.valueOf(dimValues.toString()) + "维度编码不全，不能唯一定位" + this.dataInfo.getName() + "记录");
            }
            if (records != null && records.size() > 0) {
                result = (MDERecord)records.get(0);
            }
            if (result == null && (createIfNotExist || this.dataInfo.isTemporary())) {
                try {
                    result = this.newRecord(dimValues, false);
                }
                catch (DuplicationException ex) {
                    ex.printStackTrace();
                }
            }
        }
        return result;
    }

    public final boolean needLoadData(MDEDimValueSet dimValues) {
        return !this.loadedDimValues.isIncluded(dimValues);
    }

    public void dataLoaded(MDEDimValueSet dimValues) {
        this.loadedDimValues.include(dimValues);
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void loadData(DBConnect dbConnect, MDEDimValueSet dimValues) throws MDEException {
        if ((dimValues.dimensions().collectCompare(this.dataInfo.dimensions()) & 1) != 0) {
            MDEDimValueSet myDimValues = new MDEDimValueSet(this.dataInfo.dimensions());
            myDimValues.assignValues(dimValues);
            dimValues = myDimValues;
            dimValues.setValue("顺序号", null);
        } else if (dimValues.dimensions().hasOrder() && dimValues.getValue("顺序号") != null) {
            dimValues = (MDEDimValueSet)dimValues.clone();
            dimValues.setValue("顺序号", null);
        }
        if (!this.needLoadData(dimValues)) {
            return;
        }
        if (this.getIsUseLoadDataSync()) {
            Object object = this.mutexLoadData;
            synchronized (object) {
                if (!this.needLoadData(dimValues)) {
                    return;
                }
                this.loadData0(dbConnect, dimValues);
            }
        } else {
            this.loadData0(dbConnect, dimValues);
        }
    }

    private void dealDuplication(MDERecord record) throws MDEException {
        MDERecord oldRecord = this.dvFind(record.getDimValues());
        MDEField field = this.dataInfo.getIndentyField();
        if (field != null && JqLib.compareString((String)((String)record.getFieldValue(field)), (String)((String)oldRecord.getFieldValue(field))) != 0) {
            if (!this.dataInfo.dimensions().hasOrder()) {
                System.out.println(String.valueOf(this.dataInfo.getName()) + "数据库记录重码：" + record.getDimValues().toString() + "，记录被忽略");
            } else {
                System.out.println(String.valueOf(this.dataInfo.getName()) + "数据库记录重码：" + record.getDimValues().toString() + "，调整顺序号");
                record.getDimValues().setValue("顺序号", null);
                try {
                    this.add(record);
                }
                catch (DuplicationException duplicationException) {}
                record.setDimValues(record.getDimValues(), null);
            }
        } else {
            if ((oldRecord.recordFlag & 2) != 0) {
                throw new MDEException(String.valueOf(this.dataInfo.getName()) + "记录已经修改，不能再次从数据库载入");
            }
            try {
                this.remove(oldRecord);
                this.add(record);
            }
            catch (DuplicationException duplicationException) {}
        }
    }

    protected void add0(MDERecord record) throws MDEException {
        if (this.dimValuesIndex == null) {
            this.buildDimValuesIndex();
        }
        try {
            this.add(record);
        }
        catch (DuplicationException duplicationException) {
            this.dealDuplication(record);
        }
    }

    private void loadData0(DBConnect dbConnect, MDEDimValueSet dimValues) throws MDEException {
        if (this.dimValuesIndex == null) {
            this.buildDimValuesIndex();
        }
        SequencialList result = this.loadFromTable(dbConnect, dimValues);
        int index = 0;
        int count = result.size();
        while (index < count) {
            MDERecord record = (MDERecord)result.get(index);
            try {
                this.add(record);
            }
            catch (DuplicationException duplicationException) {
                this.dealDuplication(record);
            }
            ++index;
        }
        this.dataLoaded(dimValues);
    }

    public final void statModifies(List modifyRecrods, MDEDimValueSetCollection modifyDimValues) {
        int i = 0;
        int count = this.records.size();
        while (i < count) {
            MDERecord record = (MDERecord)this.records.get(i);
            if (record.isInserted() || record.isDeleted() || record.isModified()) {
                if (modifyRecrods != null) {
                    modifyRecrods.add(record);
                }
                if (modifyDimValues != null) {
                    modifyDimValues.add(record.getDimValues());
                }
            }
            ++i;
        }
    }

    public final void saveData(DBConnect dbConnect) throws MDEException {
        try {
            dbConnect.getConnection();
            try {
                this.stmtCache.clear();
                try {
                    MDERecord record;
                    int i = 0;
                    int count = this.records.size();
                    while (i < count) {
                        record = (MDERecord)this.records.get(i);
                        if (record.isInserted()) {
                            record.refreshDimValues(this.dimValuesIndex);
                        }
                        if (!record.isDeleting() && (record.isModified() || record.isInserted()) && !record.hasData()) {
                            record.delete();
                        }
                        ++i;
                    }
                    i = this.records.size() - 1;
                    while (i >= 0) {
                        MDERecord record2 = (MDERecord)this.records.get(i);
                        if (record2.isDeleting()) {
                            this.deleteRecord(dbConnect, record2);
                            this.remove(i);
                        }
                        --i;
                    }
                    i = 0;
                    count = this.records.size();
                    while (i < count) {
                        record = (MDERecord)this.records.get(i);
                        if (record.isInserted()) {
                            this.insertRecord(dbConnect, record);
                        } else if (!record.isDeleting()) {
                            record.checkModification();
                            if (record.isModified()) {
                                this.updateRecord(dbConnect, record);
                            }
                        }
                        ++i;
                    }
                }
                finally {
                    this.stmtCache.close();
                }
            }
            finally {
                dbConnect.releaseConnection();
            }
        }
        catch (SQLException ex) {
            throw new MDEException(ex);
        }
    }

    public void resetRecords() {
        this.loadedDimValues.clear();
        super.resetRecords();
    }

    protected Object readDimension(ResultSet resultSet, MDEDimension dimension, IntValue index) throws SQLException {
        if ("顺序号" == dimension.name) {
            String order = null;
            order = index == null ? resultSet.getString(dimension.fieldName) : resultSet.getString(index.value++);
            try {
                return new Integer(JqLib.parseHexValue((String)order));
            }
            catch (NumberFormatException ex) {
                System.out.println(String.valueOf(this.dataInfo.getName()) + "顺序号无效");
                ex.printStackTrace();
                return new Integer(1);
            }
        }
        if (index == null) {
            if (dimension.isString) {
                return resultSet.getString(dimension.fieldName);
            }
            return new Integer(resultSet.getInt(dimension.fieldName));
        }
        if (dimension.isString) {
            return resultSet.getString(index.value++);
        }
        return new Integer(resultSet.getInt(index.value++));
    }

    protected void writeDimension(PreparedStatement statement, MDEDimension dimension, IntValue index, Object value) throws SQLException {
        if ("顺序号" == dimension.name) {
            int order = value != null ? (Integer)value : 1;
            statement.setString(index.value++, JqLib.makeHexString((int)order));
        } else if (dimension.isString) {
            statement.setString(index.value++, (String)value);
        } else if (value instanceof Integer) {
            if (value == null) {
                statement.setNull(index.value++, 4);
            } else {
                statement.setInt(index.value++, (Integer)value);
            }
        } else if (value == null) {
            statement.setNull(index.value++, 2);
        } else {
            statement.setDouble(index.value++, (Double)value);
        }
    }

    protected Object readField(ResultSet resultSet, MDEField field, IntValue index) throws SQLException {
        if (index == null) {
            return resultSet.getObject(field.name);
        }
        return resultSet.getObject(index.value++);
    }

    protected void writeField(PreparedStatement statement, MDEField field, IntValue index, Object value) throws SQLException {
        if (value == null) {
            statement.setNull(index.value++, field.dataType);
        } else {
            statement.setObject(index.value++, value);
        }
    }

    protected final void readRecord(ResultSet resultSet, MDERecord record, boolean readDimension) throws SQLException {
        IntValue index = null;
        if (KEEP_FIELDS_ORDER) {
            index = new IntValue(1);
        }
        if (readDimension) {
            MDEDimValueSet dimValues = new MDEDimValueSet(this.dataInfo.dimensions());
            int i = 0;
            int count = this.dataInfo.dimensions().size();
            while (i < count) {
                MDEDimension dimension = this.dataInfo.dimensions().get(i);
                dimValues.setValue(i, this.readDimension(resultSet, dimension, index));
                ++i;
            }
            record.setDimValues(dimValues, null);
        }
        int i = 0;
        int count = this.fields.size();
        while (i < count) {
            MDEField field = this.fields.get(i);
            record.setFieldValue(i, this.readField(resultSet, field, index));
            ++i;
        }
    }

    protected final void writeFieldsData(PreparedStatement statement, MDERecord record, IntValue index) throws SQLException {
        int i = 0;
        int count = this.fields.size();
        while (i < count) {
            MDEField field = this.fields.get(i);
            this.writeField(statement, field, index, record.getFieldValue(i));
            ++i;
        }
    }

    protected final void writeDimensionsData(PreparedStatement statement, MDERecord record, IntValue index, boolean writeFieldDimension) throws SQLException {
        MDEDimValueSet dimValues = record.getDimValues();
        int i = 0;
        int count = this.dataInfo.dimensions().size();
        while (i < count) {
            MDEDimension dimension = this.dataInfo.dimensions().get(i);
            if (writeFieldDimension || this.fields.findByFieldName(dimension.fieldName) == null) {
                this.writeDimension(statement, dimension, index, dimValues.getValue(i));
            }
            ++i;
        }
    }

    protected final void writeRecord(PreparedStatement statement, MDERecord record, boolean writeDimension) throws SQLException {
        IntValue index = new IntValue(1);
        if (writeDimension) {
            MDEDimValueSet dimValues = record.getDimValues();
            int i = 0;
            int count = this.dataInfo.dimensions().size();
            while (i < count) {
                MDEDimension dimension = this.dataInfo.dimensions().get(i);
                if (this.fields.findByFieldName(dimension.fieldName) == null) {
                    this.writeDimension(statement, dimension, index, dimValues.getValue(i));
                }
                ++i;
            }
        }
        int i = 0;
        int count = this.fields.size();
        while (i < count) {
            MDEField field = this.fields.get(i);
            this.writeField(statement, field, index, record.getFieldValue(i));
            ++i;
        }
    }

    private final void checkEmptyFields(MDEDimValueSet dimValues, ArrayList emptyFields) {
        int i = 0;
        int count = dimValues.dimensions().size();
        while (i < count) {
            MDEDimension dim;
            Object dimValue = dimValues.getValue(i);
            if ((dimValue == null || "".equals(dimValue)) && emptyFields.indexOf(dim = dimValues.dimensions().get(i)) < 0) {
                emptyFields.add(dim);
            }
            ++i;
        }
    }

    private final void convertEmptyDimension(Connection conn, MDEDimension dim) throws SQLException {
        StringBuffer sql = new StringBuffer(80);
        sql.append("UPDATE ");
        sql.append(this.getTableName());
        sql.append(" SET ");
        sql.append(dim.fieldName);
        if (dim.isString) {
            sql.append("='_'");
        } else {
            sql.append("=99");
        }
        sql.append(" WHERE ");
        sql.append(dim.fieldName);
        if (dim.isString) {
            sql.append("= '' OR ");
        } else {
            sql.append("=0 OR ");
        }
        sql.append(dim.fieldName);
        sql.append(" IS NULL");
        Statement stmt = conn.createStatement();
        try {
            stmt.executeUpdate(sql.toString());
        }
        finally {
            stmt.close();
        }
    }

    private final void changeEmptyDimensionValue(SequencialList records, MDEDimension dim) {
        int index = 0;
        int count = records.size();
        while (index < count) {
            MDERecord rec = (MDERecord)records.get(index);
            MDEDimValueSet dimValues = rec.getDimValues();
            if (dimValues.getValue(dim) == null) {
                if (dim.isString) {
                    dimValues.setValue(dim, (Object)DEFAULT_STR_VALUE);
                } else {
                    dimValues.setValue(dim, (Object)DEFAULT_INT_VALUE);
                }
            }
            ++index;
        }
    }

    protected String convertSQL(String sql, MDEDimValueSet dimValues) {
        return sql;
    }

    protected void doLoadRecord(ResultSet rs, MDERecord record) throws SQLException, MDEException {
        record.beforeLoadRecord();
        this.readRecord(rs, record, true);
        record.afterLoadRecord();
    }

    private String generateSql(MDEDimValueSet dimValues) {
        return this.generateSql(dimValues, false);
    }

    private String generateSql(MDEDimValueSet dimValues, boolean isPrepared) {
        StringBuffer sql = null;
        if (!this.keepFieldsOrder) {
            sql = new StringBuffer(128);
            sql.append("SELECT * FROM ");
        } else {
            sql = new StringBuffer(this.fields.size() * 8 + 80);
            sql.append("SELECT ");
            int i = 0;
            int count = this.dataInfo.dimensions().size();
            while (i < count) {
                sql.append(this.dataInfo.dimensions().get((int)i).fieldName);
                sql.append(',');
                ++i;
            }
            i = 0;
            count = this.fields.size();
            while (i < count) {
                MDEField field = this.fields.get(i);
                if (this.dataInfo.dimensions().findByFieldName(field.fieldName) == null) {
                    sql.append(field.fieldName);
                    sql.append(',');
                }
                ++i;
            }
            sql.deleteCharAt(sql.length() - 1);
            sql.append(" FROM ");
        }
        sql.append(this.getTableName());
        sql.append(" WHERE ");
        sql.append(dimValues.getSQLFilter(isPrepared));
        return sql.toString();
    }

    protected void beforeReadRecord(MDEDimValueSet dimValues) {
    }

    protected void readRecord(ResultSet rs, SequencialList result, MDERecord record) throws SQLException, MDEException {
        this.doLoadRecord(rs, record);
        result.add((Object)record);
    }

    protected void afterReadRecord(MDEDimValueSet dimValues) {
    }

    protected SequencialList loadFromTable(DBConnect dbConnect, MDEDimValueSet dimValues) throws MDEException {
        SequencialList result = new SequencialList();
        boolean isPrepared = false;
        String sql = this.generateSql(dimValues);
        try {
            Connection conn = dbConnect.getConnection();
            try {
                ArrayList emptyFields = new ArrayList();
                Statement stmt = null;
                try {
                    this.beforeReadRecord(dimValues);
                    String selectSQL = this.convertSQL(sql, dimValues);
                    if (selectSQL.equals(sql)) {
                        isPrepared = true;
                        selectSQL = this.generateSql(dimValues, isPrepared);
                    }
                    stmt = conn.prepareStatement(selectSQL);
                    if (isPrepared) {
                        this.setParameter((PreparedStatement)stmt, dimValues);
                    }
                    ResultSet rs = stmt.executeQuery();
                    try {
                        while (rs.next()) {
                            MDERecord record = this.createRecord();
                            this.readRecord(rs, result, record);
                            this.checkEmptyFields(record.getDimValues(), emptyFields);
                        }
                        this.afterReadRecord(dimValues);
                    }
                    finally {
                        rs.close();
                    }
                    if (emptyFields.size() > 0) {
                        int i = 0;
                        int count = emptyFields.size();
                        while (i < count) {
                            MDEDimension dim = (MDEDimension)emptyFields.get(i);
                            this.convertEmptyDimension(conn, dim);
                            this.changeEmptyDimensionValue(result, dim);
                            ++i;
                        }
                    }
                }
                finally {
                    stmt.close();
                }
            }
            finally {
                dbConnect.releaseConnection();
            }
        }
        catch (SQLException ex) {
            throw new MDEException(ex);
        }
        return result;
    }

    private void setParameter(PreparedStatement ps, MDEDimValueSet dimValues) throws SQLException {
        if (dimValues == null) {
            return;
        }
        MDEDimensionSet dimensions = dimValues.dimensions();
        Object[] values = dimValues.getDimValues();
        int index = 1;
        if (dimensions != null) {
            int i = 0;
            while (i < dimensions.size()) {
                MDEDimension dimension = dimensions.get(i);
                Object value = values[i];
                if (value != null) {
                    index = dimension.setParameter(ps, value, index);
                }
                ++i;
            }
        }
    }

    protected final boolean insertRecord(DBConnect dbConnect, MDERecord record) throws MDEException {
        try {
            int result = 0;
            record.beforeSaveRecord();
            try {
                result = this.doInsertRecord(dbConnect, record);
            }
            catch (SQLException e) {
                if (DBConnect.isUniqueViolationException((SQLException)e)) {
                    result = this.doUpdateRecord(dbConnect, record);
                }
                throw e;
            }
            record.afterSaveRecord();
            if (MDESqlLogger.Sql_Logger != null) {
                MDESqlLogger.Sql_Logger.LogInsertSql(this.makeInsertInfo(record, result));
            }
            return result > 0;
        }
        catch (SQLException ex) {
            throw new MDEException(ex);
        }
    }

    private final int doInsertRecord(DBConnect dbConnect, MDERecord record) throws SQLException {
        String sqlString = null;
        PreparedStatement stmt = this.stmtCache.insertStatement;
        if (stmt == null) {
            StringBuffer sql = new StringBuffer(this.fields.size() * 10 + 100);
            StringBuffer param = new StringBuffer(20 + 2 * this.fields.size());
            sql.append("INSERT INTO ");
            sql.append(this.getTableName());
            sql.append(" (");
            int i = 0;
            int count = this.dataInfo.dimensions().size();
            while (i < count) {
                MDEDimension dimension = this.dataInfo.dimensions().get(i);
                if (this.fields.findByFieldName(dimension.fieldName) == null) {
                    dimension.appendInsertSql(sql, param);
                }
                ++i;
            }
            i = 0;
            count = this.fields.size();
            while (i < count) {
                sql.append(this.fields.get((int)i).fieldName);
                sql.append(',');
                param.append("?,");
                ++i;
            }
            sql.deleteCharAt(sql.length() - 1);
            param.deleteCharAt(param.length() - 1);
            sql.append(")");
            sql.append(" VALUES (");
            sql.append(param);
            sql.append(")");
            sqlString = this.convertSQL(sql.toString(), record.getDimValues());
        }
        Connection conn = dbConnect.getConnection();
        try {
            if (stmt == null) {
                this.stmtCache.insertStatement = stmt = conn.prepareStatement(sqlString);
            }
            IntValue index = new IntValue(1);
            this.writeDimensionsData(stmt, record, index, false);
            this.writeFieldsData(stmt, record, index);
            int n = stmt.executeUpdate();
            return n;
        }
        finally {
            dbConnect.releaseConnection();
        }
    }

    protected final boolean updateRecord(DBConnect dbConnect, MDERecord record) throws MDEException {
        try {
            int result = 0;
            record.beforeSaveRecord();
            result = this.doUpdateRecord(dbConnect, record);
            if (result == 0) {
                result = this.doInsertRecord(dbConnect, record);
            }
            record.afterSaveRecord();
            if (MDESqlLogger.Sql_Logger != null) {
                MDESqlLogger.Sql_Logger.LogInsertSql(this.makeUpdateInfo(record, result));
            }
            return result > 0;
        }
        catch (SQLException ex) {
            throw new MDEException(ex);
        }
    }

    private final int doUpdateRecord(DBConnect dbConnect, MDERecord record) throws SQLException {
        PreparedStatement stmt;
        MDEField identyField = this.dataInfo.getIndentyField();
        Object identyValue = identyField == null ? null : record.getFieldValue(identyField);
        String sqlString = null;
        PreparedStatement preparedStatement = stmt = identyValue == null ? this.stmtCache.updateStatement : this.stmtCache.updateByIdentyStatement;
        if (stmt == null) {
            StringBuffer sql = new StringBuffer(this.fields.size() * 10 + 100);
            sql.append("UPDATE ");
            sql.append(this.getTableName());
            sql.append(" SET ");
            int i = 0;
            int count = this.fields.size();
            while (i < count) {
                sql.append(this.fields.get((int)i).fieldName);
                sql.append('=');
                sql.append("?,");
                ++i;
            }
            sql.deleteCharAt(sql.length() - 1);
            sql.append(" WHERE ");
            if (identyValue != null) {
                sql.append(identyField.fieldName);
                sql.append("=?");
            } else {
                i = 0;
                while (i < this.dataInfo.dimensions().size()) {
                    MDEDimension dimension = this.dataInfo.dimensions().get(i);
                    dimension.appendWhereClause(sql);
                    ++i;
                }
                sql.setLength(sql.length() - 4);
            }
            sqlString = this.convertSQL(sql.toString(), record.getDimValues());
        }
        Connection conn = dbConnect.getConnection();
        try {
            if (stmt == null) {
                stmt = conn.prepareStatement(sqlString);
                if (identyValue != null) {
                    this.stmtCache.updateByIdentyStatement = stmt;
                } else {
                    this.stmtCache.updateStatement = stmt;
                }
            }
            IntValue index = new IntValue(1);
            this.writeFieldsData(stmt, record, index);
            if (identyValue == null) {
                this.writeDimensionsData(stmt, record, index, true);
            } else {
                this.writeField(stmt, identyField, index, identyValue);
            }
            int n = stmt.executeUpdate();
            return n;
        }
        finally {
            dbConnect.releaseConnection();
        }
    }

    protected final boolean deleteRecord(DBConnect dbConnect, MDERecord record) throws MDEException {
        try {
            record.beforeDeleteRecord();
            int result = this.doDeleteRecord(dbConnect, record);
            record.afterDeleteRecord();
            if (MDESqlLogger.Sql_Logger != null) {
                MDESqlLogger.Sql_Logger.LogInsertSql(this.makeDeleteInfo(record.getDimValues(), result));
            }
            return result > 0;
        }
        catch (SQLException ex) {
            throw new MDEException(ex);
        }
    }

    private final int doDeleteRecord(DBConnect dbConnect, MDERecord record) throws SQLException {
        PreparedStatement stmt;
        MDEField identyField = this.dataInfo.getIndentyField();
        Object identyValue = identyField == null ? null : record.getFieldValue(identyField);
        String sqlString = null;
        PreparedStatement preparedStatement = stmt = identyValue == null ? this.stmtCache.deleteStatement : this.stmtCache.deleteByIdentyStatement;
        if (stmt == null) {
            StringBuffer sql = new StringBuffer(this.fields.size() * 10 + 100);
            sql.append("DELETE FROM ");
            sql.append(this.getTableName());
            sql.append(" WHERE ");
            if (identyValue != null) {
                sql.append(identyField.fieldName);
                sql.append("=?");
            } else {
                int i = 0;
                while (i < this.dataInfo.dimensions().size()) {
                    MDEDimension dimension = this.dataInfo.dimensions().get(i);
                    dimension.appendWhereClause(sql);
                    ++i;
                }
                sql.setLength(sql.length() - 4);
            }
            sqlString = this.convertSQL(sql.toString(), record.getDimValues());
        }
        Connection conn = dbConnect.getConnection();
        try {
            if (stmt == null) {
                stmt = conn.prepareStatement(sqlString);
                if (identyValue != null) {
                    this.stmtCache.deleteByIdentyStatement = stmt;
                } else {
                    this.stmtCache.deleteStatement = stmt;
                }
            }
            IntValue index = new IntValue(1);
            if (identyValue == null) {
                this.writeDimensionsData(stmt, record, index, true);
            } else {
                this.writeField(stmt, identyField, index, identyValue);
            }
            int n = stmt.executeUpdate();
            return n;
        }
        finally {
            dbConnect.releaseConnection();
        }
    }

    public int deleteRecords(DBConnect dbConnect, MDEDimValueSet dimValues) throws SQLException {
        String filter;
        if (!dimValues.dimensions().equals(this.dataInfo.dimensions())) {
            MDEDimValueSet newDimValues = new MDEDimValueSet(this.dataInfo.dimensions());
            newDimValues.assignValues(dimValues);
            dimValues = newDimValues;
        }
        if ((filter = dimValues.getSQLFilter()) == null || filter.length() == 0) {
            return 0;
        }
        Connection conn = dbConnect.getConnection();
        try {
            int n;
            Statement stmt = conn.createStatement();
            try {
                StringBuffer sql = new StringBuffer(128);
                sql.append("DELETE FROM ");
                sql.append(this.getTableName());
                sql.append(" WHERE ");
                sql.append(filter);
                int result = stmt.executeUpdate(this.convertSQL(sql.toString(), dimValues));
                if (MDESqlLogger.Sql_Logger != null) {
                    MDESqlLogger.Sql_Logger.LogInsertSql(this.makeDeleteInfo(dimValues, result));
                }
                n = result;
            }
            catch (Throwable throwable) {
                stmt.close();
                throw throwable;
            }
            stmt.close();
            return n;
        }
        finally {
            dbConnect.releaseConnection();
        }
    }

    protected String getTableName() {
        return this.dataInfo.getName();
    }

    private void writeFieldValues(MDERecord record, StringBuffer sb) {
        int i = 0;
        int count = this.fields.size();
        while (i < count) {
            MDEField field = this.fields.get(i);
            sb.append('\t');
            sb.append(field.name);
            sb.append('=');
            Object value = record.getFieldValue(i);
            sb.append(value != null ? value.toString() : "");
            ++i;
        }
    }

    private String makeInsertInfo(MDERecord record, int retCode) {
        StringBuffer sb = new StringBuffer(2048);
        sb.append(MDESqlLogger.getLogTime());
        sb.append("\tINSERT\t");
        sb.append(this.getTableName());
        sb.append('\t');
        sb.append(retCode);
        sb.append('\t');
        sb.append(record.getDimValues().toString());
        this.writeFieldValues(record, sb);
        sb.append('\t');
        return sb.toString();
    }

    private String makeUpdateInfo(MDERecord record, int retCode) {
        StringBuffer sb = new StringBuffer(2048);
        sb.append(MDESqlLogger.getLogTime());
        sb.append("\tUPDATE\t");
        sb.append(this.getTableName());
        sb.append('\t');
        sb.append(retCode);
        sb.append('\t');
        sb.append(record.getDimValues().toString());
        this.writeFieldValues(record, sb);
        sb.append('\t');
        return sb.toString();
    }

    private String makeDeleteInfo(MDEDimValueSet dimValues, int retCode) {
        StringBuffer sb = new StringBuffer(2048);
        sb.append(MDESqlLogger.getLogTime());
        sb.append("\tDELETE\t");
        sb.append(this.getTableName());
        sb.append('\t');
        sb.append(retCode);
        sb.append('\t');
        sb.append(dimValues.toString());
        sb.append('\t');
        return sb.toString();
    }
}

